// 2014.08.08 Updated fix for LW 11.x
//
// Petter Sundnes
// petter@mentalfish.com
//
// If you add other transformation features to the script, then please
// post it in the NewTek forum and/or send me an email.

@version 2.6
@warnings
@script modeler
@name "MF Circlify"

var polyGroups;
var polyGroupsCnt = 0;
var polysToSelect = 0;

main
{
	undogroupbegin();

	selmode(DIRECT);
	polyCntArray = polycount();
	polyCnt = polyCntArray[1];
	if(polyCnt<1)
	{
		info("Please select some polygons.");
		return;
	}


	extractPolyGroups();

	for(g=1;g<=polyGroupsCnt;g++)
	{

		selmode(USER);
		selpolygon(CLEAR);
		selpolygon(SET,POLYID,polyGroups[g]);

		selmode(USER);
		editbegin();
			(origPoly) = polygons;
		editend();

		startBounds = boundingbox();
		startCenter = center(startBounds);

		currLayer = lyrfg();
		backLayer =  lyrempty();

		copy();
		editbegin();
			origPoly = polygons;
		editend();
		lyrsetfg(backLayer[1]);
		paste();



		selpolygon(CLEAR);
		selpolygon(SET,PATCH);

		selmode(DIRECT);
			editbegin();
				anySelected = polygons;
			editend();

			if(anySelected)
				togglepatches();

		selmode(USER);
		selpolygon(CLEAR);

		offset = center(boundingbox());
		move(-offset);

		selpolygon(SET,POLYNDX,1);
		selpolygon(SET,CONNECT);

		cmdseq("Extender");
		mergepols();

		scale(0,center(boundingbox()));
		mergepoints(1);

		delete();

		selpolygon(SET,POLYNDX,1);
		selpolygon(SET,CONNECT);
		cmdseq("Select Outline");

		positionBeforeKneeding = center(boundingbox());
		for(n=1; n<=10; n++) // ...kneed it into a circle
		{
			//smooth(10,1); // <- makes it go wonky in LW10 and 11
			move(center(boundingbox()) * -1);
			meshedit("Spherize");
			move(center(boundingbox()) * -1);
		}
		//move(positionBeforeKneeding);

		selpolygon(SET,POLYNDX,1);
		selpolygon(SET,CONNECT);
		mergepols();

		move(offset);

		currentbounds = boundingbox();
		//sizeDiff = (startBounds[1] - startBounds[2]) / (currentbounds[1] - currentbounds[2]);
		sizeDiff = (startBounds[1] - startBounds[2]);

		sizeScale = sqrt(sizeDiff.x*sizeDiff.x + sizeDiff.y*sizeDiff.y + sizeDiff.z*sizeDiff.z)*0.25;

		scale(sizeScale, startCenter);

		editbegin();
			(currPoly) = polygons;
			tempCounter = 1;
			pointPos;
			foreach(pnt,points)
			{
				pointPos[tempCounter++] = <pnt.x,pnt.y,pnt.z>;
			}
		editend();

		delete();
		delete();

		lyrsetfg(currLayer[1]);

		selpolygon(SET,POLYID,origPoly);
		mergepols();

		editbegin();
			tempCounter = 1;
			foreach(pnt,points)
			{
				pnt.x = pointPos[tempCounter].x;
				pnt.y = pointPos[tempCounter].y;
				pnt.z = pointPos[tempCounter++].z;
			}
			(finalPoly) = polygons;
		editend();

		cmdseq("Extender");
		scale(0,center(boundingbox()));

		cmdseq("Select Expand");
		cmdseq("Sel Polys");
		mergepoints(0.0001);

		selmode(DIRECT);
		triangulatedPolys;
		editbegin();
			triangulatedPolys = polygons;
		editend();

		selpolygon(CLEAR);
		toggler = 1;
		prevTri;
		quadCount = -1;

		foreach(p,triangulatedPolys)
		{
			if (toggler == 1 && prevTri != nil)
			{
				selpolygon(SET,POLYID,p);
				selpolygon(SET,POLYID,prevTri);
				mergepols();
			}
			else if(toggler == -1)
			{
				prevTri = p;
			}
			selpolygon(CLEAR);
			toggler *= -1;
			quadCount++;
		}
		quadCount = quadCount/2;

		selpolygon(CLEAR);
		selpolygon(SET,NVEQ,1);
		selpolygon(SET,NVEQ,2);
		delete();

		selpoint(CLEAR);
		selpoint(SET,NPEQ,0);
		delete();

		polysToSelect += quadCount;

	}

	selmode(USER);
	selpolygon(CLEAR);
	editbegin();
		finalModel = polygons;
		polycnt = sizeof(finalModel);
	editend();
	for(n=0;n<polysToSelect;n++)
	{
		selpolygon(SET,POLYNDX,(polycnt - n));
	}

	undogroupend();
}

polygons {
	editbegin();
	polys = polygons;
	editend();
	return polys;
}

extractPolyGroups
{
	selmode(USER);
	selhide(UNSELECTED);

	cut(); paste();

	polyCntArray = polycount();
	polyCnt = polyCntArray[1];

	while(polyCnt)
	{
		selmode(USER);
		selpolygon(SET,POLYNDX,1);
		selpolygon(SET,CONNECT);
		polyGroups[++polyGroupsCnt] = polygons();
		selhide(SELECTED);
		selmode(GLOBAL);
		polyCntArray = polycount();
		polyCnt = polyCntArray[1];
	}
	selunhide();
	mergepoints();
}
